hdu 5389 Zero Escape

Problem Description
Zero Escape, is a visual novel adventure video game directed by Kotaro Uchikoshi (you may hear about ever17?) and developed by Chunsoft.

Stilwell is enjoying the first chapter of this series, and in this chapter digital root is an important factor.

This is the definition of digital root on Wikipedia:
The digital root of a non-negative integer is the single digit value obtained by an iterative process of summing digits, on each iteration using the result from the previous iteration to compute a digit sum. The process continues until a single-digit number is reached.
For example, the digital root of 65536 is 7 , because 6+5+5+3+6=25 and 2+5=7 .

In the game, every player has a special identifier. Maybe two players have the same identifier, but they are different players. If a group of players want to get into a door numbered X(1X9) , the digital root of their identifier sum must be X .
For example, players {1,2,6} can get into the door 9 , but players {2,3,3} can't.

There is two doors, numbered A and B . Maybe A=B , but they are two different door.
And there is n players, everyone must get into one of these two doors. Some players will get into the door A , and others will get into the door B .
For example:
players are {1,2,6} , A=9 , B=1
There is only one way to distribute the players: all players get into the door 9 . Because there is no player to get into the door 1 , the digital root limit of this door will be ignored.

Given the identifier of every player, please calculate how many kinds of methods are there, mod 258280327 .
 

Input
The first line of the input contains a single number T , the number of test cases.
For each test case, the first line contains three integers n , A and B .
Next line contains n integers idi , describing the identifier of every player.
T100 , n105 , n106 , 1A,B,idi9
 

Output
For each test case, output a single integer in a single line, the number of ways that these n players can get into these two doors.
 

Sample Input
  
  
4 3 9 1 1 2 6 3 9 1 2 3 3 5 2 3 1 1 1 1 1 9 9 9 1 2 3 4 5 6 7 8 9
 

Sample Output
  
  
1 0 10 60
解答:

题意也有点复杂,得好好读懂题意。

每组样例中,n代表接下来一行的n个数,使这n个数分成两组,每组的根分别为a和b。并且可以所有的n个数都在一组中,另一组为空。

a和b的根的和等于n个数的根。我们只要判断n个数中有多少组成a就好。

一个数字的根=它mod9之后的数字+1


int tempnum=(j+num[i+1])%9;
                    dp[i+1][tempnum]=(dp[i+1][tempnum]+dp[i][j])%MOD;
                    dp[i+1][j]=(dp[i+1][j]+dp[i][j])%MOD;


#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;
#define N 100010
#define MOD 258280327

int num[N];
long long int dp[N][10];

int main(){
    int t;
    int n;
    int a,b;
    int sum;

    scanf("%d",&t);
    while(t--){
        scanf("%d%d%d",&n,&a,&b);
        sum=0;
        for(int i=1;i<=n;i++){
            scanf("%d",&num[i]);
            sum+=num[i];
        }
        if(sum==0){
            printf("0\n");
        }
        else if((a+b)%9!=sum%9||a+b>sum){
            if(a%9==sum%9||b%9==sum%9){
                printf("1\n");
            }
            else{
                printf("0\n");
            }
        }
        else{
            memset(dp,0,sizeof(dp));
            dp[0][0]=1;
            for(int i=0;i<n;i++){
                for(int j=0;j<=8;j++){
                    int tempnum=(j+num[i+1])%9;
                    dp[i+1][tempnum]=(dp[i+1][tempnum]+dp[i][j])%MOD;
                    dp[i+1][j]=(dp[i+1][j]+dp[i][j])%MOD;
                }
            }

            printf("%d\n",dp[n][a%9]);
        }
    }

    return 0;
}


害羞

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值